"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.renderToHtml = renderToHtml;

var _react = _interopRequireDefault(require("react"));

var _server = require("react-dom/server");

var _shiki = require("shiki");

const defaultPreStyle = bg => ({
  backgroundColor: bg,
  padding: "0.75rem",
  borderRadius: "0.25rem",
  position: "relative"
});

const defaultToolbarStyle = {
  display: "flex",
  position: "absolute",
  right: 0,
  top: 0,
  color: "#eee",
  backgroundColor: "#393939",
  padding: "0.125rem 0.425rem",
  borderRadius: "0.125rem"
};

function renderToHtml(lines, options = {}) {
  const {
    bg = "#fff",
    langId = "",
    classPrefix
  } = options;
  const randomId = Math.floor(Math.random() * 65535);

  let node = /*#__PURE__*/_react.default.createElement("pre", {
    className: `${classPrefix}${langId}`,
    style: defaultPreStyle(bg)
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "toolbar",
    style: defaultToolbarStyle
  }, langId && /*#__PURE__*/_react.default.createElement("div", {
    className: "language-id",
    style: {}
  }, langId), /*#__PURE__*/_react.default.createElement("div", {
    className: "copy-button",
    style: {
      marginLeft: "0.45rem"
    }
  }, /*#__PURE__*/_react.default.createElement("button", {
    className: "copy-btn",
    "data-clipboard-target": `#code-${randomId}`
  }, "copy"))), /*#__PURE__*/_react.default.createElement("code", {
    className: "code",
    id: `code-${randomId}`
  }, lines.map(l => /*#__PURE__*/_react.default.createElement("div", {
    key: l.toString(),
    className: "line"
  }, l.map(token => {
    const cssDeclarations = {
      color: token.color || options.fg
    };

    if (token.fontStyle & _shiki.FontStyle.Italic) {
      cssDeclarations.fontStyle = "italic";
    }

    if (token.fontStyle & _shiki.FontStyle.Bold) {
      cssDeclarations.fontWeight = "bold";
    }

    if (token.fontStyle & _shiki.FontStyle.Underline) {
      cssDeclarations.textDecoration = "underline";
    }

    return /*#__PURE__*/_react.default.createElement("span", {
      key: token.content,
      style: cssDeclarations
    }, token.content);
  })))));

  return (0, _server.renderToString)(node);
}